#include <16f877A.h>  
#device adc=10  
#fuses HS,NOWDT,NOLVP,NOCPD,NODEBUG 
#use delay(clock=4M)   
#define useTimer1
 
float volt, oldval, volt1; 
int count = 0;
unsigned int8 time = 0, clap = 0;
 
#ifdef useTimer1
#INT_TIMER1
void TIMER1_isr(void)
{    
   if(interrupt_active(int_timer1)) 
   {
          time++;            
   }
   
   set_timer1(0x0BDB);
   clear_interrupt(int_timer1);
} 
#elif useTimer2
 
#int_timer2 
void timer2_isr(void)  
{ 
    ;
}    
#endif
 
void clear(){
    clap = 0;
    time = 0;
    disable_interrupts(INT_TIMER1);
}
 
void main() 
{ 
    set_tris_a(0xff); 
    set_tris_b(0x00); 
    set_tris_c(0x00); 
    set_tris_d(0x00); 
     
    //Analog module configuration for reading the voltage from the PIN_AN0 
    setup_comparator(NC_NC_NC_NC); 
    setup_adc(ADC_CLOCK_INTERNAL); 
    setup_adc_ports(AN0); 
    set_adc_channel(0);  
    setup_vref(FALSE);
    
    //Timer Configuration
    #ifdef useTimer1
        //Timer1
        //Prescaler 1:8; TMR1 Preload = 3035; Actual Interrupt Time : 500 ms
        setup_timer_1(T1_INTERNAL|T1_DIV_BY_8);
        set_timer1(0x0BDB);
    #elif
        //Code for Timer2 configuration
        
    #endif
    
    enable_interrupts(GLOBAL); 
         
    while(1) 
    { 
        delay_us(20); 
        read_adc(adc_start_only); 
        delay_us(100); 
        volt = read_adc(adc_read_only); 
        volt = volt * 5.0/ 1023.0; 
                 
        if((volt > 1) && (clap == 0))
{
              clap++;
              enable_interrupts(INT_TIMER1);
      // output_high(PIN_D3); //new inserted
			time = 0;
        }      
        
        if((volt > 1) && (clap == 1))
				{
                if(time < 4)
				{ 
                        clap++;
                        //output_low(PIN_D3);
                   output_high(PIN_D3);//new inserted
                        clear();
            }           
        }
        
       // if((clap == 1) && (time > 4)){
		if((clap ==1) && (time > 4)){
                output_low(PIN_D3);//high modified to low for shut down
                clear();                
        }
    }     
}